// 27.02.2009 - 24.05.2009 by Tebe/Madteam

// 06.08.2011 - add SDX file information by Mono/Jerzy Kut


// Free Pascal Compiler, http://www.freepascal.org/
// Compile: fpc -Mdelphi -vh -O3 chkxex.pas


program checkXEX;

{$APPTYPE CONSOLE}

//uses
//  SysUtils;

var
  buf: array [0..$FFFF] of byte;

  plik: file;


function TestFile(var a: string): Boolean;
(*----------------------------------------------------------------------------*)
(*  sprawdzamy istnienie pliku na dysku bez udzialu 'SysUtils',               *)
(*  jest to odpowiednik funkcji 'FileExists'                                  *)
(*----------------------------------------------------------------------------*)
var IORes: integer;
    pl: textfile;
begin
 Result:=true;

 AssignFile(pl, a);
 {$I-}
 FileMode:=0;
 Reset(pl);
 {$I+ }
 IORes:=IOResult;

 if IORes<>0 then Result:=false else CloseFile(pl);
end;


function Hex(a:cardinal; b:shortint): string;
(*----------------------------------------------------------------------------*)
(*  zamiana na zapis hexadecymalny                                            *)
(*  'B' okresla maksymalna liczbe nibbli do zamiany                           *)
(*  jesli sa jeszcze jakies wartosci to kontynuuje zamiane                    *)
(*----------------------------------------------------------------------------*)
var v: byte;

const
    tHex: array [0..15] of char =
    ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');

begin
 Result:='';

 while (b>0) or (a<>0) do begin

  v := byte(a);
  Result:=tHex[v shr 4] + tHex[v and $0f] + Result;

  a:=a shr 8;

  dec(b,2);
 end;

end;


procedure get(const i: integer; var len: integer);
begin
 blockread(plik, buf, i);

 inc(len, i);
end;

function ToDec(v, n: integer): string;
const
    tDec: array [0..9] of char =
    ('0','1','2','3','4','5','6','7','8','9');
var i: integer;
begin
  Result:='';
  for i:= 0 to n-1 do begin
    Result:=tDec[v mod 10]+Result;
    v:=v div 10;
  end;
end;

function GetUpdateBlock(var flen, i: integer): boolean;
begin
  Result:=true;
  while true do begin 
    if i+1>flen then begin Result:=false; Break end;
    get(1, i);
    case buf[0] of
      $fe: begin
          if i+1>flen then begin Result:=false; Break end;
          get(1, i);
        end;
      $fd: begin
          if i+2>flen then begin Result:=false; Break end;
          get(2, i);
        end;
      $fc: Break;
    end;
  end;
end;

procedure LoadXEX(fnam: string);
var t, r: string;
    h, n, b, x, y, l, flen, i, no: integer;
    ok: Boolean;
begin

  if not(TestFile(fnam)) then begin
   writeln('File ''',fnam,''' not found.');
   exit;
  end;

  assignfile(plik, fnam); reset(plik,1);
  flen:=FileSize(plik);

  i:=0;

  get(2, i);

  h:=buf[0]+buf[1] shl 8;
  if h<$FFFA then begin
   writeln('Invalid file header.');
   exit;
  end;

// odczyt pliku w formacie Atari DOS lub Sparta DOS

 reset(plik,1);
 i:=0;

 ok:=true;

 no:=1;

 while i<flen do begin

  if i+2>flen then begin ok:=false; Break end;
  get(2, i);
  h:=buf[0]+buf[1] shl 8;

  if h=$FFFE then begin
    // sparta relocatable block
    if i+6>flen then begin ok:=false; Break; end;
    get(6, i);
    
    n:=buf[0];
    b:=buf[1];
    x:=buf[2]+buf[3] shl 8;
    y:=buf[4]+buf[5] shl 8;

    l:=y;
    if (b and $80)=0 then begin
      if i+l>flen then begin ok:=false; Break end;
      get(l, i);
    end;

    if (b and $7f)=0 then t:='MAIN'
    else if (b and $7f)=4 then t:='EXTENDED'
    else t:='???';
    if (b and $80)=$80 then r:='EMPTY'
    else r:='RELOC';
    writeln(ToDec(no,3)+': SDX $'+Hex(x,4)+'   #'+Hex(n,1)+': $'+Hex(y,4)+'           '+r+' '+t);
  end
  else if h=$FFFD then begin
    //sparta addr update block
    if i+3>flen then begin ok:=false; Break; end;
    get(3, i);
    
    n:=buf[0];
    y:=buf[1]+buf[2] shl 8;
    
    if not GetUpdateBlock(flen, i) then begin ok:=false; Break; end;
    
    writeln(ToDec(no,3)+': SDX         #'+Hex(n,1)+': $'+Hex(y,4)+'           ADDR UPDATE');
  end
  else if h=$FFFC then begin
    //sparta symbol definition block
    if i+11>flen then begin ok:=false; Break; end;
    get(11, i);
    
    x:=buf[1]+buf[2] shl 8;
    setlength(t,8); for n:=0 to 7 do t[1+n]:=Chr(buf[3+n]);
    n:=buf[0];
    
    writeln(ToDec(no,3)+': SDX $'+Hex(x,4)+'   #'+Hex(n,1)+':       @'+t+' SYMBOL NEW');
  end
  else if h=$FFFB then begin
    //sparta symbol update block
    if i+10>flen then begin ok:=false; Break; end;
    get(10, i);
    
    setlength(t,8); for n:=0 to 7 do t[1+n]:=Chr(buf[n]);
    y:=buf[8]+buf[9] shl 8;
   
    if not GetUpdateBlock(flen, i) then begin ok:=false; Break; end;

    writeln(ToDec(no,3)+': SDX            : $'+Hex(y,4)+' @'+t+' SYMBOL UPDATE');
  end
  else begin
    // atari dos block or sparta non-relocatable block
    if (h=$FFFF) or (h=$FFFA) then begin
      if i+2>flen then begin ok:=false; Break end;
      get(2, i);
    end;
    x:=buf[0]+buf[1] shl 8;
    if i+2>flen then begin ok:=false; Break end;
    get(2, i);
    y:=buf[0]+buf[1] shl 8;

    l:=y-x+1;

    if i+l>flen then begin ok:=false; Break end;
    get(l, i);

    if h=$FFFA
    then writeln(ToDec(no,3)+': SDX $'+Hex(x,4)+' $'+Hex(y,4)+': $'+Hex(y-x+1,4)+'           SPARTA')
    else writeln(ToDec(no,3)+':     $'+Hex(x,4)+' $'+Hex(y,4)+': $'+Hex(y-x+1,4));

    if (x<=$2e0) and (y>=$2e1)
    then writeln('     RUN $'+Hex(buf[0]+buf[1] shl 8,4));
    if (x<=$2e2) and (y>=$2e3)
    then writeln('     INI $'+Hex(buf[0]+buf[1] shl 8,4));
  end;

  inc(no, 1);
 end;


 if (i<>flen) or not(ok) then
  writeln('File ''',fnam,''' is too short.')
 else
  writeln('File ''',fnam,''' is OK.');

 closefile(plik);
end;


begin

 if ParamCount>0 then
  LoadXEX( ParamStr(1) )
 else
  writeln('Syntax: chkxex filename.xex');

end.
